#include <iostream>
using namespace std;
int main(){
    int n; cin>>n;
    int o;
    int a;
    int b;
    int ab;
    bool mogucnost=true;
    cin>>o>>a>>b>>ab;
    int arr[n][4];
    for(int i=0;i<n;i++){
        arr[i][0]=0;
        arr[i][1]=0;
        arr[i][2]=0;
        arr[i][3]=0;
        string c;
        int d;
        cin>>c>>d;
        if(c=="O"){
            if(o>=d){
                o-=d;
                arr[i][0]=d;
            }
            else{
                mogucnost=false;
                break;
            }
        }
        else if(c=="A"){
            if(a>=d){
                a-=d;
                arr[i][1]=d;
            }
            else if((a+o)>=d){
                arr[i][0]=d-a;
                arr[i][1]=a;
                o=o-d+a;
                a=0;
            }
            else{
                mogucnost=false;
                break;
            }
        }
        else if(c=="B"){
            if(b>=d){
                b-=d;
                arr[i][2]=d;
            }
            else if((b+o)>=d){
                arr[i][0]=d-b;
                arr[i][2]=b;
                o=o-d+b;
                b=0;
            }
            else{
                mogucnost=false;
                break;
            }
        }
        else{
            if(ab>=d){
                ab-=d;
                arr[i][3]=d;
                d=0;
            }
            else{
                d-=ab;
                arr[i][3]=ab;
                ab=0;
            }
        }
    }
    if(mogucnost){
        cout<<"moguce"<<endl;
        for(int i=0;i<n;i++){
            for(int j=0;j<4;j++){
                cout<<arr[i][j]<<' ';
            }
        cout<<endl;
        }
    }
    else{
        cout<<"nemoguce"<<endl;
    }
    return 0;


}